Create Identity Provider (SAML XML Metadata)
POST {{apiPath}}/v1/environments/{{envID}}/identityProviders
This operation adds a new SAML identity provider to the environment based on the configuration properties specified in a metadata XML file. The Content-Type header must be set to application/samlmetadata+xml.
Example Request
-
cURL
-
C#
-
Go
-
HTTP
-
Java
-
jQuery
-
NodeJS
-
Python
-
PHP
-
Ruby
-
Swift
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/identityProviders' \
--header 'Content-Type: application/samlmetadata+xml' \
--header 'Accept: application/json, */*' \
--header 'Authorization: Bearer {{accessToken}}' \
--data-binary '@/Users/johnbudz/Desktop/valid_saml20_idp_metadata.xml'
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/identityProviders")
{
MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/samlmetadata+xml");
request.AddHeader("Accept", "application/json, */*");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
request.AddParameter("application/samlmetadata+xml", "<file contents here>", ParameterType.RequestBody);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "{{apiPath}}/v1/environments/{{envID}}/identityProviders"
method := "POST"
payload := strings.NewReader("<file contents here>")
client := &http.Client {
}
req, err := http.NewRequest(method, url, payload)
if err != nil {
fmt.Println(err)
return
}
req.Header.Add("Content-Type", "application/samlmetadata+xml")
req.Header.Add("Accept", "application/json, */*")
req.Header.Add("Authorization", "Bearer {{accessToken}}")
res, err := client.Do(req)
if err != nil {
fmt.Println(err)
return
}
defer res.Body.Close()
body, err := io.ReadAll(res.Body)
if err != nil {
fmt.Println(err)
return
}
fmt.Println(string(body))
}
POST /v1/environments/{{envID}}/identityProviders HTTP/1.1
Host: {{apiPath}}
Content-Type: application/samlmetadata+xml
Accept: application/json, */*
Authorization: Bearer {{accessToken}}
"<file contents here>"
OkHttpClient client = new OkHttpClient().newBuilder()
.build();
MediaType mediaType = MediaType.parse("application/samlmetadata+xml");
RequestBody body = RequestBody.create(mediaType, "<file contents here>");
Request request = new Request.Builder()
.url("{{apiPath}}/v1/environments/{{envID}}/identityProviders")
.method("POST", body)
.addHeader("Content-Type", "application/samlmetadata+xml")
.addHeader("Accept", "application/json, */*")
.addHeader("Authorization", "Bearer {{accessToken}}")
.build();
Response response = client.newCall(request).execute();
var settings = {
"url": "{{apiPath}}/v1/environments/{{envID}}/identityProviders",
"method": "POST",
"timeout": 0,
"headers": {
"Content-Type": "application/samlmetadata+xml",
"Accept": "application/json, */*",
"Authorization": "Bearer {{accessToken}}"
},
"data": "<file contents here>"
};
$.ajax(settings).done(function (response) {
console.log(response);
});
var request = require('request');
var options = {
'method': 'POST',
'url': '{{apiPath}}/v1/environments/{{envID}}/identityProviders',
'headers': {
'Content-Type': 'application/samlmetadata+xml',
'Accept': 'application/json, */*',
'Authorization': 'Bearer {{accessToken}}'
},
body: "<file contents here>"
};
request(options, function (error, response) {
if (error) throw new Error(error);
console.log(response.body);
});
import requests
url = "{{apiPath}}/v1/environments/{{envID}}/identityProviders"
payload = "<file contents here>"
headers = {
'Content-Type': 'application/samlmetadata+xml',
'Accept': 'application/json, */*',
'Authorization': 'Bearer {{accessToken}}'
}
response = requests.request("POST", url, headers=headers, data=payload)
print(response.text)
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/identityProviders');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
'follow_redirects' => TRUE
));
$request->setHeader(array(
'Content-Type' => 'application/samlmetadata+xml',
'Accept' => 'application/json, */*',
'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('<file contents here>');
try {
$response = $request->send();
if ($response->getStatus() == 200) {
echo $response->getBody();
}
else {
echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
$response->getReasonPhrase();
}
}
catch(HTTP_Request2_Exception $e) {
echo 'Error: ' . $e->getMessage();
}
require "uri"
require "net/http"
url = URI("{{apiPath}}/v1/environments/{{envID}}/identityProviders")
http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/samlmetadata+xml"
request["Accept"] = "application/json, */*"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = "<file contents here>"
response = http.request(request)
puts response.read_body
let parameters = "<file contents here>"
let postData = parameters.data(using: .utf8)
var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/identityProviders")!,timeoutInterval: Double.infinity)
request.addValue("application/samlmetadata+xml", forHTTPHeaderField: "Content-Type")
request.addValue("application/json, */*", forHTTPHeaderField: "Accept")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")
request.httpMethod = "POST"
request.httpBody = postData
let task = URLSession.shared.dataTask(with: request) { data, response, error in
guard let data = data else {
print(String(describing: error))
return
}
print(String(data: data, encoding: .utf8)!)
}
task.resume()
Example Response
200 OK
{
"entityId": "https://pingone.com/idp/cd-11110000.pingidentity",
"ssoEndpointConfig": [
{
"binding": "HTTP_POST",
"endpoint": "https://sso.connect.pingidentity.com/sso/idp/SSO.saml2?idpid=270e6413-c8b0-40b6-bad2-9befa04fdf1c"
},
{
"binding": "HTTP_REDIRECT",
"endpoint": "https://sso.connect.pingidentity.com/sso/idp/SSO.saml2?idpid=270e6413-c8b0-40b6-bad2-9befa04fdf1c"
}
],
"sloEndpointConfig": [
{
"binding": "HTTP_REDIRECT",
"endpoint": "https://sso.connect.pingidentity.com/sso/SLO.saml2",
"responseEndpoint": "https://sso.connect.pingidentity.com/sso/responseUrl"
},
{
"binding": "HTTP_POST",
"endpoint": "https://sso.connect.pingidentity.com/sso/SLO.saml2",
"responseEndpoint": "https://sso.connect.pingidentity.com/sso/responseUrl"
}
],
"signingCertificates": [
{
"pkcs7Der": "MIAGCSqGSIb3D..."
},
{
"pkcs7Der": "MIAGCSqGSIb3..."
}
],
"encryptionCertificate": {
"pkcs7Der": "MIAGCSqGSIb3D..."
}
}